/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package sakila.util;


import org.hibernate.Session;
import org.hibernate.cfg.AnnotationConfiguration;
import org.hibernate.SessionFactory;

/**
 * Hibernate Utility class with a convenient method to get Session Factory object.
 *
 * @author nb
 */
public class HibernateUtil {
    private static final SessionFactory sessionFactory;
    public static final ThreadLocal<Session> session = new ThreadLocal<>();

    static {
        try {
            // Create the SessionFactory from standard (hibernate.cfg.xml) 
            // config file.
            sessionFactory = new AnnotationConfiguration().configure().buildSessionFactory();
        } catch (Throwable ex) {
            // Log the exception. 
            System.err.println("Initial SessionFactory creation failed." + ex);
            throw new ExceptionInInitializerError(ex);
        }
    }

    public static SessionFactory getSessionFactory() {
        return sessionFactory;
    }
    
      @SuppressWarnings("unchecked")
    public static void closeSession() {
        Session s = session.get();

        if (s != null) {
            s.close();
        }

        session.set(null);
    }

    /**
     *  Description of the Method
     *
     * @return    Description of the Return Value
     */
    @SuppressWarnings("unchecked")
    public static Session openSession() {
        Session s = session.get();

        // Open a new Session, if this Thread has none yet
        if (s == null) {
            s = sessionFactory.openSession();
            session.set(s);
        }

        return s;
    }
}
